LeetCode 81 - Search in Rotated Sorted Array II


Related: Searching an Element in a Rotated Sorted Array | LeetCode
Follow up for LeetCode - Search in Rotated Sorted Array: what if duplicates are allowed? Would this affect the run-time complexity? How and why? Write a function to determine if a given target is in the array.

https://discuss.leetcode.com/topic/25487/neat-java-solution-using-binary-search/2
No need to check two parts. We must have one part sorted while the other part rotated.
public boolean search(int[] nums, int target) {
    int start  = 0, end = nums.length - 1;
    
    //check each num so we will check start == end
    //We always get a sorted part and a half part
    //we can check sorted part to decide where to go next
    while(start <= end){
        int mid = start + (end - start)/2;
        if(nums[mid] == target) return true;
        
        //if left part is sorted
        if(nums[start] < nums[mid]){
            if(target < nums[start] || target > nums[mid]){
                //target is in rotated part
                start = mid + 1;
            }else{
                end = mid - 1;
            }
        }else if(nums[start] > nums[mid]){
            //right part is rotated
            
            //target is in rotated part
            if(target < nums[mid] || target > nums[end]){
                end = mid -1;
            }else{
                start = mid + 1;
            }
        }else{
            //duplicates, we know nums[mid] != target, so nums[start] != target
            //based on current information, we can only move left pointer to skip one cell
            //thus in the worest case, we would have target: 2, and array like 11111111, then
            //the running time would be O(n)
            start ++;
        }
    }
    
    return false;
}
http://codesniper.blogspot.com/2015/03/81-search-in-rotated-sorted-array-ii.html
Now duplicates are allowed in the array, which will make the search a little bit more tricky. For those two cases: num[mid]<num[right](right part is sorted) or num[mid]>mid[right](left part is sorted), we can still cut the search range half as problem 33 suggested. However, when num[mid]==num[right], we can't cut either half of the array, because, both of them can contain the target. Eg. target is 1. Array A: {2,2,1,2,2,2,2} and Array B: {2,2,2,2,1,2,2}, both the arrays have the property of num[mid]==num[right], but right part of A is sorted and target is in left half, while right part of B is not sorted and target is in the right half. so when this case happens, we can only guarantee that, mid number and right number is not the target, and we can't cut the range half, so the worst time complexity will increase to O(n) which we have all same elements in the array but are not the target value.
http://bangbingsyb.blogspot.com/2014/11/leetcode-search-in-rotated-sorted-array.html
当有重复数字,会存在A[mid] = A[end]的情况。此时右半序列A[mid-1 : end]可能是sorted,也可能并没有sorted,如下例子。

3 1 2 3 3 3 3 
3 3 3 3 1 2 3

所以当A[mid] = A[end] != target时,无法排除一半的序列,而只能排除掉A[end]:

A[mid] = A[end] != target时:搜寻A[start : end-1]

正因为这个变化,在最坏情况下,算法的复杂度退化成了O(n):
序列 2 2 2 2 2 2 2 中寻找target = 1。
bool search(int A[], int n, int target) {
        int start = 0, end = n-1;
        while(start<=end) {
            int mid = start + (end-start)/2;
            if(A[mid]==target) return true;  
       
            if(A[mid]<A[end]) { // right half sorted
                if(target>A[mid] && target<=A[end])
                    start = mid+1;
                else
                    end = mid-1;
            }
            else if(A[mid]>A[end]) {  // left half sorted
                if(target>=A[start] && target<A[mid]) 
                    end = mid-1;
                else
                    start = mid+1;
            }
            else {
                end--;
            }
        }
        return false;
    }
Just when A[left]==A[center], we cannot say the previous part is ordered, then we just go to the next element and check again.
public boolean search(int[] A, int target) {
        if (A == null || A.length == 0)
            return false;
        int left = 0, right = A.length - 1;
        // Apply binary search when it is sure which part is sorted
        while (left <= right) {
            int center = (left+right) / 2;
            if (A[center] == target)        // Target found
                return true;
            if (A[center] > A[left]) {  // The left part is sorted
                if (target >= A[left] && target < A[center])
                    right = center - 1;
                else
                    left = center + 1;
            } else if (A[center] < A[left]) {   // The right part is sorted
                if (target <= A[right] && target > A[center])
                    left = center + 1;
                else
                    right = center - 1;
            } else {    // cannot say which part is sorted
                left++;
            }
        }
        return false;
    }
X. https://discuss.leetcode.com/topic/45207/intuitive-java-recursive-solution-using-binary-search-avg-o-log-n-worst-case-o-n
    public boolean helper(int[] nums, int start, int end, int target) {
        if(start>end)
            return false;
        int mid = start + (end - start) / 2;
        if(nums[mid] == target)
            return true;
        if(nums[start] < nums[mid]) {
            if(target >= nums[start] && target < nums[mid])
                return helper(nums, start, mid-1, target);
            else
                return helper(nums, mid+1, end, target);
        } else if(nums[start] > nums[mid]) {
            if(target > nums[mid] && target <= nums[end])
                return helper(nums, mid+1, end, target);
            else
                return helper(nums, start, mid-1, target);
        } else {
            if(nums[mid]==nums[end]) // in this case, the smaller or larger values (compare to nums[mid]) can be in either side
                return helper(nums, start, mid-1, target) || helper(nums, mid+1, end, target);
            else // this case we are sure that the left-side of mid are all duplicates
                return helper(nums, mid+1, end, target);
        }
    }
http://www.programcreek.com/2014/06/leetcode-search-in-rotated-sorted-array-ii-java/
https://tenderleo.gitbooks.io/leetcode-solutions-/content/GoogleMedium/81.html
we can see that one half of the array must be ordered normally (in increasing order). We can therefore look at the normally ordered half to determine whether we should search the left or right half.

int search(int a[], int left, int right, int x) {
        int mid= (left+ right)/ 2;
        if (x == a[mid]) {//Found element
                return mid;
        }
        if (right< left) {
                return -1;
        }

        /* Either the left or right half must be normally ordered. Find out which side
         * is normally ordered, and then use the normally ordered half to figure out
         * which side to search to find x. */
        if (a[left] < a[mid]) {//Left is normally ordered.
                if (x >= a[left] && x < a[mid]) {
                        return search(a, left, mid - 1, x); // Search left
                } else {
                        return search(a, mid+ 1, right, x); // Search right
                }
        } else if (a[mid] < a[left]) {//Right is normally ordered.
                if (x > a[mid] && x <= a[right]) {
                        return search(a, mid+ 1, right, x); // Search right
                } else {
                        return search(a, left, mid - 1, x); // Search left
                }
        } else if (a[left] == a[mid]) {//Left or right half is all repeats
                if (a[mid] != a[right]) {//If right is different, search it
                        return search(a, mid+ 1, right, x); // search right
                } else {//Else, we have to search both halves
                        int result= search(a, left, mid - 1, x); // Search left
                        if (result == -1) {
                                return search(a, mid+ 1, right, x); // Search right
                        } else {
                                return result;
                        }
                }
        }
        return -1;
}
Read full article from LeetCode - Search in Rotated Sorted Array II | Darren's Blog

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts